const https = require('https')
let express = require('express')
let app = express()
let fs = require('fs')
let moment = require('moment')

let privateKey = fs.readFileSync('./ssl/cert.key')
let certificate = fs.readFileSync('./ssl/cert.crt')

let server = null
let useSecure = false
let port = 8099

if (useSecure) {
  server = https.createServer({
      key: privateKey,
      cert: certificate,
      requestCert: false,
      rejectUnauthorized: false
  }, app).listen(port)
} else {
  server = require('http').Server(app).listen(port)
}

let io = require('socket.io').listen(server)

io.on('connection', function (socket) {
  console.log('connection')

  // команды от эмулятора на изменение состояния робота
  socket.on('emulator-state', function(data) {
    console.log('emulator-state', data)
  })

  // команды от эмулятора отправляем в приложение, как будто их отправил робот
  socket.on('emulator-command', function(data) {
    console.log('emulator-command', data)
  })

  // логируем события из приложения
  socket.on('event', function(data) {
    console.log('event', data)
  })

  // получаем сообщения от приложения и эмулируем ответы робота на них
  socket.on('api', function(data) {
    console.log('api', data)
  })
})
